' Mandeldink
' (c) 2015 by Abby Normal
' based on  https://en.wikipedia.org/wiki/Mandelbrot_set#For_programmers

w = 640: h = 480
startX = -2.5
startY = -1.5
endX = 1
endY = 1.5

stepX = (endX - startX) / w
stepY = (endY - startY) / h

SCREEN _NEWIMAGE(w, h, 256)
WINDOW (startX, startY)-(endX, endY)

FOR x0 = startX TO endX STEP stepX
    FOR y0 = startY TO endY STEP stepY
        x = 0
        y = 0
        iteration = 0
        max_iteration = 1000
        WHILE (x ^ 2 + y ^ 2 < 4 AND iteration < max_iteration)
            xtemp = x ^ 2 - y ^ 2 + x0
            y = 2 * x * y + y0
            x = xtemp
            iteration = iteration + 1
        WEND
        IF iteration = max_iteration THEN colr = 0 ELSE colr = iteration + 32
        PSET (x0, y0), colr
    NEXT y0
NEXT x0

